<?php
/**
*
* @package contrib
* @version $Id:
* @copyright (c) 2007 Jiri Smika (Smix) http://phpbb3.smika.net
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
$user->session_begin();
$auth->acl($user->data);
$user->setup();
$user->add_lang('mods/lastrss');

// this release version info
$version = '2.0.0RC';

// only admin can install/update this mod - nobody else can run this script
if(!($user->data['user_type']) == USER_FOUNDER)
{
  trigger_error($user->lang['LASTRSS_INSTALL_FOUNDER_REQUIRED'],  E_USER_ERROR);
}

// check if constants exists
if (!defined('LASTRSS_RSSLIST_TABLE') || !defined('LASTRSS_RSSCONTENT_TABLE'))
{
  trigger_error($user->lang['LASTRSS_DO_EDITS_AT_FIRST'], E_USER_ERROR);
}

// is lastrss agregator mod already installed ?
if(isset($config['lastrss_version']))
{
  // lastrss is already installed
  // version check
  if($version == $config['lastrss_version']) 
  {
    // this version is already installed - do nothing
    trigger_error('<span style="color:darkorange; font-weight:bold;">' . sprintf($user->lang['LASTRSS_INSTALL_ALREADY_INSTALLED'], $version) . '</span>');
  }
  // weird ? :-D ... 
  elseif($version < $config['lastrss_version']) 
  {
    // do the update
    $sql_array = array(
      'DROP TABLE IF EXISTS ' . LASTRSS_RSSCONTENT_TABLE . ';',
      'DROP TABLE IF EXISTS ' . LASTRSS_RSSLIST_TABLE . ';',
      'CREATE TABLE ' . LASTRSS_RSSCONTENT_TABLE . ' (
          name varchar(50) NOT NULL,
          content blob NOT NULL,
          PRIMARY KEY  (name)
        );',
      'CREATE TABLE ' . LASTRSS_RSSLIST_TABLE . ' (
        url varchar(255) NOT NULL,
        last_update varchar(10) NOT NULL,
        name varchar(50) NOT NULL,
        level int(3) NOT NULL,
        enabled int(1) NOT NULL,
        PRIMARY KEY  (name)
      );',
      'INSERT INTO ' . LASTRSS_RSSCONTENT_TABLE . ' VALUES (\'phpBB.com\', \'\');',
      'INSERT INTO ' . LASTRSS_RSSCONTENT_TABLE . ' VALUES (\'lastRSS home\', \'\');',
      'INSERT INTO ' . LASTRSS_RSSLIST_TABLE . ' VALUES (\'http://phpbb3.smika.net/lastrss.php\', \'0\', \'lastRSS home\', \'99\', \'1\');',
      'INSERT INTO ' . LASTRSS_RSSLIST_TABLE . ' VALUES (\'http://www.phpbb.com/feeds/rss/\', \'0\', \'phpBB.com\', \'90\', \'1\');',
      'UPDATE ' . CONFIG_TABLE . ' SET config_value = \'curl\' WHERE config_name = \'lastrss_type\';',
      'UPDATE ' . CONFIG_TABLE . ' SET config_value = \''.$version.'\' WHERE config_name = \'lastrss_version\';',
    );
  }
}
else
{
  // INSTALL latest version
  // If you have problems with this install script, insert this into db manually
  $sql_array = array(
    'CREATE TABLE ' . LASTRSS_RSSCONTENT_TABLE . ' (
        name varchar(50) NOT NULL,
        content blob NOT NULL,
        PRIMARY KEY  (name)
      );',
    'CREATE TABLE ' . LASTRSS_RSSLIST_TABLE . ' (
      url varchar(255) NOT NULL,
      last_update varchar(10) NOT NULL,
      name varchar(50) NOT NULL,
      level int(3) NOT NULL,
      enabled int(1) NOT NULL,
      PRIMARY KEY  (name)
    );',
    'INSERT INTO ' . LASTRSS_RSSCONTENT_TABLE . ' VALUES (\'phpBB.com\', \'\');',
    'INSERT INTO ' . LASTRSS_RSSCONTENT_TABLE . ' VALUES (\'lastRSS home\', \'\');',
    'INSERT INTO ' . LASTRSS_RSSLIST_TABLE . ' VALUES (\'http://phpbb3.smika.net/lastrss.php\', \'0\', \'lastRSS home\', \'99\', \'1\');',
    'INSERT INTO ' . LASTRSS_RSSLIST_TABLE . ' VALUES (\'http://www.phpbb.com/feeds/rss/\', \'0\', \'phpBB.com\', \'90\', \'1\');',
    'INSERT INTO ' . CONFIG_TABLE . ' VALUES (\'lastrss_cache_time\', \'12\', \'0\');',
    'INSERT INTO ' . CONFIG_TABLE . ' VALUES (\'lastrss_enabled\', \'0\', \'1\');',
    'INSERT INTO ' . CONFIG_TABLE . ' VALUES (\'lastrss_items_limit\', \'3\', \'0\');',
    'INSERT INTO ' . CONFIG_TABLE . ' VALUES (\'lastrss_shuffle\', \'0\', \'0\');',
    'INSERT INTO ' . CONFIG_TABLE . ' VALUES (\'lastrss_type\', \'fopen\', \'0\');',
    'INSERT INTO ' . CONFIG_TABLE . ' VALUES (\'lastrss_version\', \''.$version.'\', \'0\');',
  );
}

// DO THE INSTALL OR UPDATE
$count = sizeof($sql_array);
if ($count > 0)
{
  for($i = 0, $count; $i < $count; $i++)
  {
    if(!$db->sql_query($sql_array[$i]))
  	{
  		trigger_error('ERROR during sql query : ' . $sql_array[$i], E_USER_ERROR);
  	}
    // refresh cache
    $cache->destroy('config');
  }
  trigger_error('<span style="color:green; font-weight:bold;">' . sprintf($user->lang['LASTRSS_INSTALL_SUCCESSFULL'], $version) . '</span>');
}
else
{
  trigger_error('Nothing to change in db', E_USER_ERROR);
}

?>
