<?php
/** 
*
* @package acp
* @version $Id:
* @copyright (c) 2007 Jiri Smika (Smix) http://phpbb3.smika.net
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/
		
if (!defined('IN_PHPBB'))
{
	exit;
}
	
/**
* @package acp
*/
class acp_lastrss
{
	var $u_action;
					
	function main($id, $mode)
	{
		global $cache, $db, $user, $auth, $template;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;
					
		$user->add_lang('mods/lastrss');
							
		$submit	= isset($_POST['submit']) ? true : false;					
					
		switch($mode)
    {	
      // lastrss configuration (enabled/disabled, fopen/curl)
      case 'config':	
        
        if($submit)
        { 
          // Set up general vars
       		$enabled	= (int)request_var('enabled', '0');
      		$connection	= request_var('connection', 'curl');
      		$cache_time	= (int)request_var('cache_time', '12');
      		$items_limit	= (int)request_var('items_limit', '3');
      		$shuffle	= (int)request_var('shuffle', '0');
      		
      		// check for valid cache_time
      		if(($cache_time < 0) || ($cache_time =='') || ($cache_time > '168'))
          {
            trigger_error($user->lang['ACP_LASTRSS_CACHE_TIME_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
          }
      		
          // update config 
          set_config('lastrss_enabled', $enabled);
          set_config('lastrss_type', $connection);
          set_config('lastrss_cache_time', $cache_time);
          set_config('lastrss_items_limit', $items_limit);
          set_config('lastrss_shuffle', $shuffle);
          // refresh cached configuration
          $cache->destroy('config');
          $cache->purge();
          trigger_error($user->lang['ACP_LASTRSS_CONFIGURATION_UPDATED'] . adm_back_link($this->u_action), E_USER_NOTICE);
        }
        else
        {
          // get values from db
          $cache_time = $config['lastrss_cache_time'];
          $enabled = $config['lastrss_enabled'];
          $connection = $config['lastrss_type'];
          $items_limit = $config['lastrss_items_limit'];
          $shuffle = $config['lastrss_shuffle'];
        }

        // set template and assign vars
		    $this->page_title 	= $user->lang['ACP_LASTRSS_FULL'] . ' - ' . $user->lang['ACP_LASTRSS_CONFIGURATION'];
        $this->tpl_name 	= 'acp_lastrss';
        $template->assign_vars(array(
          'S_LASTRSS_VERSION' => $config['lastrss_version'],
  				'S_LASTRSS'			=> $user->lang['ACP_LASTRSS_FULL'],
  				'S_LASTRSS_EXPLAIN'			=> $user->lang['ACP_LASTRSS_EXPLAIN_CONFIGURATION'], 
          'S_EXPLAIN' => $user->lang['ACP_LASTRSS_CONFIGURATION_LEGEND'], 
          'S_LASTRSS_ENABLE' => $user->lang['ACP_LASTRSS_ENABLE'], 
          'LASTRSS_ENABLED'				=> $enabled,
          'S_LASTRSS_CONNECTION' => $user->lang['ACP_LASTRSS_CONNECTION'], 
          'S_LASTRSS_CONNECTION_EXPLAIN' => $user->lang['ACP_LASTRSS_CONNECTION_EXPLAIN'], 
          'S_LASTRSS_CURL' => $user->lang['ACP_LASTRSS_CURL'], 
          'S_LASTRSS_FOPEN' => $user->lang['ACP_LASTRSS_FOPEN'],
          'FOPEN' => ($connection=='fopen') ? true : false, 
          'S_LASTRSS_CACHING'=> $user->lang['ACP_LASTRSS_CACHING_TIME'],
          'CACHE_TIME' => $cache_time,
          'S_LASTRSS_ITEMS_LIMIT'=> $user->lang['ACP_LASTRSS_ITEMS_LIMIT'],
          'S_LASTRSS_ITEMS_LIMIT_EXPLAIN'=> $user->lang['ACP_LASTRSS_ITEMS_LIMIT_EXPLAIN'],
          'ITEMS_LIMIT' => $items_limit,
          'S_LASTRSS_SHUFFLE'=> $user->lang['ACP_LASTRSS_SHUFFLE'],
          'S_LASTRSS_SHUFFLE_EXPLAIN'=> $user->lang['ACP_LASTRSS_SHUFFLE_EXPLAIN'],
          'SHUFFLE' => $shuffle,
          )
        ); 	
        break;

      // feeds management
      case 'feeds':
        // default action - manage feeds
        $action = request_var('action', 'manage');
        // switch type
        switch($action)
        {        
          // add new rss channel
          case 'new':
            if($submit)
            { 
              // Set up general vars
          		$feeds_name	= request_var('feeds_name', '');
          		$feeds_url	= request_var('feeds_url', '');
          		$feeds_level	= (int)request_var('feeds_level', '50');
          		$feeds_enabled	= (int)request_var('feeds_enabled', '0');
          		if( ($feeds_name != '') && ( $feeds_url != '') )
          		{
                // insert new row to rss list
                $sql = 'INSERT INTO ' . LASTRSS_RSSLIST_TABLE . ' (url, last_update, name, level, enabled) 
                        VALUES ("' . $db->sql_escape($feeds_url) . '", "0" , "' . $db->sql_escape($feeds_name) . '", "' . $db->sql_escape($feeds_level) . '", "' . $db->sql_escape($feeds_enabled) . '");';
                if(!($result = $db->sql_query($sql)))
              	{
              		trigger_error($user->lang['ACP_LASTRSS_FEED_ADDED_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
              	} 
              	// insert new row to content rss table
                $sql = 'INSERT INTO ' . LASTRSS_RSSCONTENT_TABLE . ' ( name, content )
                        VALUES ("'. $db->sql_escape($feeds_name)	.'", "")';
                if(!($result = $db->sql_query($sql)))
              	{
              		trigger_error($user->lang['ACP_LASTRSS_FEED_ADDED_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
              	}            
                trigger_error($user->lang['ACP_LASTRSS_FEED_ADDED'] . adm_back_link($this->u_action), E_USER_NOTICE);   
              }
              else
              {
                trigger_error($user->lang['ACP_LASTRSS_FEED_ADD_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
              } 
            }
            // prepare options list
            for ($i = 100, $options_list = ''; $i > 0; $i--) 
            {
              $options_list .= '<option value="'.$i.'">'.$i.'</option>';
            }
            // assign vars
            $template->assign_vars(array(               
      				'CHOSEN' => true,
      				'OPTIONS_LIST' => $options_list,
              )
            ); 
          break;  
          
          // remove selected rss channel
          case 'delete':
            $rss_id = request_var('rss_id', '');
            
            // ask user to confirm
    				if (confirm_box(true))
    				{ 
    				  if($rss_id!='')
    				  {
    				    // delete from rss list
                $sql = 'DELETE FROM ' . LASTRSS_RSSLIST_TABLE . ' 
                        WHERE name  = "' . $db->sql_escape($rss_id) . '" 
                        LIMIT 1';  
                if(!($result = $db->sql_query($sql)))
              	{
              		trigger_error($user->lang['ACP_LASTRSS_FEED_DELETED_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
              	}
              	// delete stored data from db too
                $sql = 'DELETE FROM ' . LASTRSS_RSSCONTENT_TABLE . ' 
                        WHERE name  = "' . $db->sql_escape($rss_id) . '" 
                        LIMIT 1'; 
                if(!($result = $db->sql_query($sql)))
              	{
              		trigger_error($user->lang['ACP_LASTRSS_FEED_DELETED_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
              	}
      					trigger_error($user->lang['ACP_LASTRSS_FEED_DELETED'] . adm_back_link($this->u_action), E_USER_NOTICE);
              } 
    				}
    				confirm_box(false, $user->lang['ACP_LASTRSS_CONFIRM_DELETE_FEED'], build_hidden_fields(array('rss_id' => $rss_id)));				
          break;
          
          // manage existing
          case 'manage':
            // prepare rsslist data
            $rsslist = array();
            $sql = 'SELECT name, url, last_update, level, enabled
                    FROM ' . LASTRSS_RSSLIST_TABLE . '
                    WHERE 1
                    ORDER BY level,enabled DESC';
            if(!($result = $db->sql_query($sql)))
          	{
          	  trigger_error('Could not get RSS list!' . adm_back_link($this->u_action), E_USER_WARNING);
          	} 
            else
            {
              $i = 0;
              while($row = $db->sql_fetchrow($result))
              { 
                $rsslist[$i]['name'] = $row['name'];
                $rsslist[$i]['url'] = $row['url'];
                $rsslist[$i]['last_update'] = $row['last_update'];
                $rsslist[$i]['level'] = $row['level'];
                $rsslist[$i]['enabled'] = $row['enabled'];
                $i++;
              }
            }
            $length = count($rsslist);
            // end preparing rsslist data
          
            // is some feed chosen ? - grab his id
            $rss_id	= request_var('rss_id', '');
    		    $chosen	= ($rss_id != '') ? true : false;
            if(!$chosen)
            { 
              // feed is not chosen - show list
              for ($i = 0; $i < $length; $i++) 
              {
                $template->assign_block_vars('listrow', array(
                  'NAME'       => $rsslist[$i]['name'],
            		  'URL'				 => $rsslist[$i]['url'],
                  'LEVEL'      => $rsslist[$i]['level'],
                  'ENABLED'      => $rsslist[$i]['enabled'],
                  'LAST_UPDATE' => ($rsslist[$i]['last_update'] > 0) ? sprintf($user->lang['ACP_LASTRSS_FEEDS_BEFORE_HOUR'], (round((time() - $rsslist[$i]['last_update']) / 3600))) : sprintf($user->lang['ACP_LASTRSS_FEEDS_NEVER']),
                  'U_NAME_MANAGE' => append_sid("{$phpbb_admin_path}index.$phpEx", "i=lastrss&amp;mode=feeds&amp;action=manage&amp;rss_id=".$rsslist[$i]['name']), 
                  'U_NAME_DELETE' => append_sid("{$phpbb_admin_path}index.$phpEx", "i=lastrss&amp;mode=feeds&amp;action=delete&amp;rss_id=".$rsslist[$i]['name']),
                  )
              	);
              }
            }
            else 
            {
              // feed IS chosen ! 
              if($submit)
              { 
                // Set up general vars
            		$feeds_name	= request_var('feeds_name', '');
            		$feeds_url	= request_var('feeds_url', '');
            		$feeds_level	= (int)request_var('feeds_level', '50');
            		$feeds_enabled	= (int)request_var('feeds_enabled', '0');
            		if(($feeds_name != '') && ($feeds_url != '') && ($rss_id!=''))
            		{
                  // update rss list with values for $rss_id = name
                  $sql = 'UPDATE ' . LASTRSS_RSSLIST_TABLE . ' 
                          SET url = "' . $db->sql_escape($feeds_url) . '",
                              level = "' . $db->sql_escape($feeds_level) .'",
                              last_update = "0", 
                              name = "' . $db->sql_escape($feeds_name) . '",
                              enabled = "' . $db->sql_escape($feeds_enabled) . '"
                          WHERE name  = "' . $db->sql_escape($rss_id) . '" 
                          LIMIT 1';          
                  if(!($result = $db->sql_query($sql)))
                	{
                		trigger_error($user->lang['ACP_LASTRSS_FEEDS_UPDATED_ERROR_DB'] . adm_back_link($this->u_action), E_USER_WARNING);
                	} 
                  // update content for $rss_id = name
                  $sql = 'UPDATE ' . LASTRSS_RSSCONTENT_TABLE . ' 
                          SET content = "",
                              name = "' . $db->sql_escape($feeds_name) . '"
                          WHERE name  = "' . $db->sql_escape($rss_id) . '" 
                          LIMIT 1';
                  if(!($result = $db->sql_query($sql)))
                	{
                		trigger_error($user->lang['ACP_LASTRSS_FEEDS_UPDATED_ERROR_DB'] . adm_back_link($this->u_action), E_USER_WARNING);
                	}
                  trigger_error($user->lang['ACP_LASTRSS_FEEDS_UPDATED'] . adm_back_link($this->u_action), E_USER_NOTICE);
                }
                else
                {
                  trigger_error($user->lang['ACP_LASTRSS_FEEDS_UPDATED_ERROR'] . adm_back_link($this->u_action), E_USER_WARNING);
                } 
              }
              // data are already in $rsslist
              // find position of $rss_id in $rss_list
              $i = 0;
              while($rsslist[$i]['name'] != $rss_id)
              {   
                $i++;
              }
              // get actual data for $rss_id
              $template->assign_vars(array(
                'V_NAME'       => $rsslist[$i]['name'],
            		'V_URL'				 => $rsslist[$i]['url'],
                'V_LAST_UPDATE'=> '-'.(round((time() - $rsslist[$i]['last_update']) / 60 / 60 )).'h' ,
                'V_LEVEL'=> $rsslist[$i]['level'],
                'V_ENABLED'=> $rsslist[$i]['enabled'], 
                )
              );
              // prepair options for levels in form
              $option_selected = $rsslist[$i]['level'];
              $options_list = '';
              for ($i=100; $i>0; $i--) 
              {
                ($i == $option_selected) ? $options_list .= '<option value="'.$i.'" selected>'.$i.'</option>' : $options_list .= '<option value="'.$i.'">'.$i.'</option>';
              }
              // assign vars
              $template->assign_vars(array(               
        				'OPTIONS_LIST' => $options_list,
        				'CHOSEN' => $chosen,
                )
              );
            }
          break;
        }
        
        // assign template vars "globaly"
        $this->page_title 	= $user->lang['ACP_LASTRSS_FULL'] . ' - ' . $user->lang['ACP_LASTRSS_FEEDS'];
        $this->tpl_name 	= 'acp_lastrss_feeds';
        $template->assign_vars(array(
          'A_NEW' => $user->lang['ACP_LASTRSS_F_ACTION_NEW'],
          'A_MANAGE' => $user->lang['ACP_LASTRSS_F_ACTION_MANAGE'],
          'S_LASTRSS_VERSION' => $config['lastrss_version'],
  				'S_LASTRSS'			=> $user->lang['ACP_LASTRSS_FULL'],
  				'S_LASTRSS_EXPLAIN'			=> $user->lang['ACP_LASTRSS_EXPLAIN_FEEDS'],
  				'S_LASTRSS_FEEDS' => $user->lang['ACP_LASTRSS_FEEDS_LEGEND'], 
    			'S_LASTRSS_FEEDS_NAME' => $user->lang['ACP_LASTRSS_FEEDS_NAME'], 
  				'S_LASTRSS_FEEDS_NAME_EXPLAIN' => $user->lang['ACP_LASTRSS_FEEDS_NAME_EXPLAIN'],
  				'S_LASTRSS_FEEDS_URL' => $user->lang['ACP_LASTRSS_FEEDS_URL'],
  				'S_LASTRSS_FEEDS_URL_EXPLAIN' => $user->lang['ACP_LASTRSS_FEEDS_URL_EXPLAIN'],
  				'S_LASTRSS_FEEDS_LEVEL' => $user->lang['ACP_LASTRSS_FEEDS_LEVEL'],
  				'S_LASTRSS_FEEDS_LEVEL_EXPLAIN' => $user->lang['ACP_LASTRSS_FEEDS_LEVEL_EXPLAIN'],
  				'S_LASTRSS_FEEDS_LAST' => $user->lang['ACP_LASTRSS_FEEDS_LAST'],
  				'S_LASTRSS_FEEDS_LAST_EXPLAIN' => $user->lang['ACP_LASTRSS_FEEDS_LAST_EXPLAIN'],
  				'S_LASTRSS_FEEDS_ENABLE' => $user->lang['ACP_LASTRSS_FEEDS_ENABLE'],  				
  				'S_LASTRSS_FEEDS_ENABLE_EXPLAIN' => $user->lang['ACP_LASTRSS_FEEDS_ENABLE_EXPLAIN'],
  				'S_LASTRSS_FEEDS_STATUS' => $user->lang['ACP_LASTRSS_FEEDS_STATUS'],
  				'ACTION' => $action,
  				'U_ACTION_NEW' => append_sid("{$phpbb_admin_path}index.$phpEx", "i=lastrss&amp;mode=feeds&amp;action=new"),
  				'U_ACTION_MANAGE' => append_sid("{$phpbb_admin_path}index.$phpEx", "i=lastrss&amp;mode=feeds&amp;action=manage"),
          )
        ); 
        break;
      }
	 }
}		
?>
