<?php
/**
*
* @package includes
* @version $Id: $
* @copyright (c) 2007-2008 Jiri Smika (Smix) http://phpbb3.smika.net
* @          (c) 2003-2004 original lastRSS by Vojtech Semecky http://lastrss.oslab.net/
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @main class
*/
class lastrss 
{
  /**
   * @ignore public properties
   */
  var $default_cp = 'UTF-8';
  var $cdata = 'strip';
  var $items_limit = 0;
  var $striphtml = true;
  var $date_format = 'U';
  
  /** 
   * @ignore private variables
   */	 
  var $channeltags = array ('title', 'link', 'description', 'language', 'copyright', 'managingEditor', 'webMaster', 'lastBuildDate', 'rating', 'docs');
	var $itemtags = array('title', 'link', 'description', 'author', 'category', 'comments', 'enclosure', 'guid', 'pubDate', 'source');
	var $imagetags = array('title', 'url', 'link', 'width', 'height');
	var $textinputtags = array('title', 'description', 'name', 'link');

  /**
   *  returns content gathered with CURL   
   *  @param string (URL) 
   */
  function curl_get_rss($rss)
  {
    // initiate and set options
    $ch = @curl_init($rss['url']);
    @curl_setopt( $ch, CURLOPT_RETURNTRANSFER, 1);
    @curl_setopt( $ch, CURLOPT_HEADER, 0);
    @curl_setopt( $ch, CURLOPT_FOLLOWLOCATION, 1);
    @curl_setopt( $ch, CURLOPT_ENCODING, '');
    @curl_setopt( $ch, CURLOPT_USERAGENT, 'lastRSS'); 
    // initial connection timeout
    @curl_setopt( $ch, CURLOPT_CONNECTTIMEOUT, 5);
    // setting this to higher means longer time for loading the page for user!
    @curl_setopt( $ch, CURLOPT_TIMEOUT, 60);
    @curl_setopt( $ch, CURLOPT_MAXREDIRS, 0);
    // get content
    $result['content'] = @curl_exec($ch);
    $result['errno'] = @curl_errno($ch);
    $result['errmsg'] = @curl_error($ch);
    $result['getinfo'] = @curl_getinfo($ch);
    @curl_close($ch);
    // if we have error data for log
    if($result['errmsg']!='')
    {
      add_log('critical', 'LOG_ERROR_LASTRSS', 'RSS: ' . $rss['name'] . ' ('.$rss['url'].')<br />Feed wasn´t updated, because <b>' . $result['errmsg'] .'</b>');
    }
    else
    {
      // merge arrays with new data
      $result = array_merge($rss, $result);
    }
    return $result;
  }

  /** 
   * specific lastRSS agregator MOD function  
   * returns RSS data from db if applicable, 
   * or downloads new RSS data and updates old data 
   * and returns data directly 
   */	 
  function get_rss($rss) 
  {
    global $db;
    // check if it´s time to get new data or not
    if (($this->cache_time + $rss['last_update']) > time())
    {
      $sql = 'SELECT content
              FROM ' . LASTRSS_RSSCONTENT_TABLE . '
              WHERE name = "' . ($rss['name']) . '"
              LIMIT 1';
      if(!($result = $db->sql_query($sql)))
      {
        trigger_error('ERROR getting lastRSS content from DB.', E_USER_ERROR);
      }
      $result = $db->sql_fetchrow($result);
      return unserialize($result['content']);
    }
    else
    { 
      // connect and download fresh data
      $result = $this->parse($rss);    
      // do we have some items
      if(isset($result['items']) && (sizeof($result['items']) > 0))
      {
        // update data in database
        $sql = 'UPDATE ' . LASTRSS_RSSCONTENT_TABLE . '
                SET content = "' . $db->sql_escape(serialize($result)) . '"
                WHERE name = "' . $rss['name'] . '"
                LIMIT 1 ;';   
        if(!$update = $db->sql_query($sql))
      	{
      	  trigger_error('ERROR updating lastRSS content', E_USER_ERROR);
      	}
        else
        { 
          // update time of last check
          $sql = 'UPDATE ' . LASTRSS_RSSLIST_TABLE . ' 
                  SET last_update = "' . time() . '" 
                  WHERE name = "' . $rss['name'] . '" 
                  LIMIT 1 ;';
          if(!$update = $db->sql_query($sql))
        	{
        	   trigger_error('ERROR updating lastRSS list', E_USER_ERROR);
        	}
        }  
        return $result;
      }
      else
      { 
        // update time of last check
        $sql = 'UPDATE ' . LASTRSS_RSSLIST_TABLE . ' 
                SET last_update = "' . time() . '" 
                WHERE name = "' . $rss['name'] . '" 
                LIMIT 1 ;';
        if(!$update = $db->sql_query($sql))
      	{
      	   trigger_error('ERROR updating lastRSS list', E_USER_ERROR);
      	}
        add_log('critical', 'LOG_ERROR_LASTRSS', 'RSS: ' . $rss['name'] . '<br />Items not found. <br />Check the URL if it is RSS feed (NO ATOM or other formats) and if yes, is the feed valid?');
        return false;
      }   
    }
  }

  /**
   * modified preg_match(); returns trimed field with index 1
   * from 'classic' preg_match() array output	 
   */   	
  function my_preg_match($pattern, $subject) 
  {
  	// start regullar expression
  	preg_match($pattern, $subject, $out);
  	// if there is some result... process it and return it
  	if(isset($out[1])) 
    {
  		// cdata
  		$out[1] = strtr($out[1], array('<![CDATA['=>'', ']]>'=>''));
  		
  		if((isset($this->rsscp))&&($this->rsscp != 'UTF-8'))
  		{
  		  // recode with phpBB´s functions
        $out[1] = utf8_recode($out[1],$this->rsscp);
      }

      // Return result
  		return trim($out[1]); 	
  	} 
    else 
    {
  	  // if there is NO result, return empty string
  		return '';
  	}
  }
  
  /**
  * replace HTML entities &something; by real characters
  * @param string  
  */     
  function unhtmlentities ($string) 
  {
		// Get HTML entities table
		$trans_tbl = get_html_translation_table (HTML_ENTITIES, ENT_QUOTES);
		// Flip keys<==>values
		$trans_tbl = array_flip ($trans_tbl);
		// Add support for &apos; entity (missing in HTML_ENTITIES)
		$trans_tbl += array('&apos;' => "'");
		// Replace entities by values
		return strtr($string, $trans_tbl);
  }

  /**
  *  parse() is private method used by getrss() to load and parse RSS file    
  *  @param string (URL)  
  */     
  function parse($rss_data) 
  {
    global $rss;
  	// open and load RSS file
    // use curl if enabled 
  	if($rss->type == 'curl')
  	{ 
      $rss_content = $this->curl_get_rss($rss_data);
    } 
  	else 
    { 
      // else use fopen if possible
      if($f = @fopen($rss_data['url'], 'r')) 
      { 
  			while (!feof($f)) 
        {
  				@$rss_content['content'] .= fgets($f, 4096);
  				$rss_content = array_merge($rss_data,$rss_content);
  			}
  			fclose($f);	
      }
    }
    // if download was succesfull
  	if(isset($rss_content['content']) && (sizeof($rss_content['content'])>0))
    {	
  		// parse document encoding
  		$result['encoding'] = $this->my_preg_match("'encoding=[\'\"](.*?)[\'\"]'si", $rss_content['content']);
  		// if document encoding is specified, use it
  		if (isset($result['encoding']))
  		{ 
        $this->rsscp = $result['encoding'];   
      }
  		else
  		{ 
  		  // otherwise use the default encoding
        $this->rsscp = $this->default_cp;     
        add_log('critical', 'LOG_ERROR_LASTRSS', 'RSS: ' . $rss_data['name'] . '<br />Feed tag "encoding" unavailable, characters can be damaged.');
      } 

  		// parse channel info
  		preg_match("'<channel.*?>(.*?)</channel>'si", $rss_content['content'], $out_channel);
  		foreach($this->channeltags as $channeltag)
  		{
  			$temp = @$this->my_preg_match("'<$channeltag.*?>(.*?)</$channeltag>'si", $out_channel[1]);
  			if (isset($temp))
        {
          $result[$channeltag] = $temp; 
        } 
  		}
  		// parse textinput info
  		// This a little strange regexp means:
  		// Look for tag <textinput> with or without any attributes, but skip truncated version <textinput /> (it's not beggining tag)
  		preg_match("'<textinput(|[^>]*[^/])>(.*?)</textinput>'si", $rss_content['content'], $out_textinfo);
  		if (isset($out_textinfo[2])) 
      {
  			foreach($this->textinputtags as $textinputtag) 
        {
  				$temp = $this->my_preg_match("'<$textinputtag.*?>(.*?)</$textinputtag>'si", $out_textinfo[2]);
  				if (isset($temp)) 
          {
            $result['textinput_'.$textinputtag] = $temp; 
          }
  			}
  		}
  		// parse images
  		preg_match("'<image.*?>(.*?)</image>'si", $rss_content['content'], $out_imageinfo);
			if (isset($out_imageinfo[1])) 
      {
				foreach($this->imagetags as $imagetag) 
        {
					$temp = $this->my_preg_match("'<$imagetag.*?>(.*?)</$imagetag>'si", $out_imageinfo[1]);
					if ($temp != '') 
          {
            $result['image_'.$imagetag] = $temp;
          }
				}
			}
			
  		// parse items
  		preg_match_all("'<item(| .*?)>(.*?)</item>'si", $rss_content['content'], $items);
  		$rss_items = $items[2];
  		// init item counter
  		$i = 0;
  		foreach($rss_items as $rss_item) 
      {  
  			// If number of items is lower then limit: parse one item
  			if ($i < $this->items_limit || $this->items_limit == 0) 
        {
  				foreach($this->itemtags as $itemtag) 
          {
  					$temp = $this->my_preg_match("'<$itemtag.*?>(.*?)</$itemtag>'si", $rss_item);
  					if (isset($temp))
            {
              $result['items'][$i][$itemtag] = $temp; 
            } 
  				}
  				// item title
  				if ($this->striphtml && isset($result['items'][$i]['title']))
  				{
            $result['items'][$i]['title'] = strip_tags($this->unhtmlentities(strip_tags($result['items'][$i]['title'])));
          }
          // item description
					if ($this->striphtml && $result['items'][$i]['description'])
						$result['items'][$i]['description'] = strip_tags($this->unhtmlentities(strip_tags($result['items'][$i]['description'])));
					// If pubDate exists
          if (isset($result['items'][$i]['pubDate'])) 
          {
            // ... and is valid
            if( (($timestamp = strtotime($result['items'][$i]['pubDate'])) !== -1) && (($timestamp = strtotime($result['items'][$i]['pubDate'])) === false) )
            {
  						// convert pubDate to specified date format
  						$result['items'][$i]['pubDate'] = $timestamp;
  					}
          }
          else
          {
            $result['items'][$i]['pubDate'] = time();
          }
  				// item counter
  				$i++;
  			}
  		}
  		$result['items_count'] = $i;
  		return $feed['content'] = $result;
  	}
  	else 
  	{
  	  // error in getting content return false
  		return $feed['error'] = true;
  	}
  }
}
?>
