<?php
/** 
*
* @package includes
* @version $Id: $
* @copyright (c) 2007 Jiri Smika (Smix) http://phpbb3.smika.net
* @license http://opensource.org/licenses/gpl-license.php GNU Public License 
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

// if lastrss is enabled
if(isset($config['lastrss_enabled']) && ($config['lastrss_enabled']))
{
  // require necessary 
  $user->add_lang('mods/lastrss');
  require $phpbb_root_path . 'includes/class_lastrss.' . $phpEx;  
  
  /**
  *  prepare array containing rss data for phpBB template
  *  data are returned from database or directly from downloaded data  
  */ 
  function get_feed_data($url) 
  {
    global $rss;
    // prepare arrays 
    $items = $msg = array();
    if(isset($url))
    {
      if ($result = $rss->get_rss($url)) 
      {
        if(isset($result))
        {
          $msg['link'] = $result['link'];
          $msg['title'] = $result['title'];
          $msg['count'] = $result['items_count'];
          $msg['hasitems'] = ($msg['count'] > 0) ? TRUE : FALSE;
          //if items available fill $items array
          if ($msg['hasitems'])
          { 
            $i = 0;
            foreach($result['items'] as $item)
            {
              $items[$i]['itemlink'] = $item['link'];
              $items[$i]['itemtitle'] = $item['title'];
              $i++;
            }
          }
          //assign items array to feed array
          $msg['items'] = $items;
        }   
      }
    }
    return $msg;
  }

  // grab list of RSS
  $sql = 'SELECT name, url, last_update, level
          FROM ' . LASTRSS_RSSLIST_TABLE . '
          WHERE enabled = "1"
          ORDER BY level DESC';
  if(!($result = $db->sql_query($sql)))
	{
		trigger_error('Could not get RSS list.', E_USER_ERROR);
	} 
  else
  {
    $i = 0;
    while($row = $db->sql_fetchrow($result))
    { 
      $rsslist[$i]['name'] = $row['name'];
      $rsslist[$i]['url'] = $row['url'];
      $rsslist[$i]['last_update'] = $row['last_update'];
      $rsslist[$i]['level'] = $row['level'];
      $i++;
    }
  } 

  // init & setup lastrss 
  $rss = new lastrss;	
  $rss->cache_time = ($config['lastrss_cache_time'] * 3600);    // time for caching source RSS in seconds 
  $rss->items_limit = $config['lastrss_items_limit'];           // default limit of items
  $rss->type = $config['lastrss_type'];                         // connection type (fopen / curl)

  // how many rss channels do we have ?
  $length = count($rsslist);
  // get sure, there is at least one rss channel in the list 
  if($length != 0)
  {
     // if shuffling enabled - run loop only once
    $length = ($config['lastrss_shuffle']) ? 1 : $length;
  
    // prepare data for template
    for ($i = 0; $i < $length; $i++) 
    {
      // get data of chosen channel
      if($config['lastrss_shuffle'])
      {
        $rss_data[$i] = get_feed_data($rsslist[rand(0,count($rsslist)-1)]);
      }
      else
      {
        $rss_data[$i] = get_feed_data($rsslist[$i]);
      }
      // if we the feed has items
      if(isset($rss_data[$i]['hasitems'])&&($rss_data[$i]['hasitems']))
      {
        // assign rss channel data
      	$template->assign_block_vars('lastrssrow', array(
            'TITLE'       => $rss_data[$i]['title'],
      		  'LINK'				=> $rss_data[$i]['link'],
            'HASITEMS'    => $rss_data[$i]['hasitems'],
            'NAME'  =>  $rsslist[$i]['name'],
          )
      	);
      	// assign rss channel items
      	$limit = ($rss_data[$i]['count'] < $config['lastrss_items_limit'])? $rss_data[$i]['count'] : $config['lastrss_items_limit'];
      	for ($j=0; $j < $limit; $j++)
        { 
          // fill only if there is next item
          if($rss_data[$i]['items'][$j]['itemtitle'] != '')
          {
            $template->assign_block_vars('lastrssrow.itemsrow', array(
            'TITLE'       => $rss_data[$i]['items'][$j]['itemtitle'],
            'LINK'				=> $rss_data[$i]['items'][$j]['itemlink'],
            'NAME'  =>  $rsslist[0]['name'],
            )
      	   );
          }
        }
      }
      else
      {
        // ERROR - FEED IS NOT AVAILABLE
        // assign rss channel data 
      	$template->assign_block_vars('lastrssrow', array(
            'HASITEMS'    => false,
            'NAME'  =>  $rsslist[0]['name'],
          )
      	);
      }
    }
    // assign the config and language vars
    $template->assign_vars(array(
      'LASTRSS_TITLE'       => $user->lang['LASTRSS_TITLE'],
		  'LASTRSS_NUM_LIST'				=> $length,
      'LASTRSS_ITEMS_LIMIT' => $config['lastrss_items_limit'],
      'LASTRSS_ENABLED' => true,
      'LASTRSS_NOTAVAILABLE'  => $user->lang['LASTRSS_NOTAVAILABLE'],
      )
  	);
  }
}
?>
